<ui:composition xmlns:gri="http://java.sun.com/jsf/composite/gri" xmlns:ui="http://java.sun.com/jsf/facelets"
                xmlns:a4j="http://richfaces.org/a4j"
                xmlns:g="http://www.ihe.net/gazelle" xmlns:gdk="http://www.ihe.net/gazellecdk"
                xmlns:f="http://java.sun.com/jsf/core" xmlns:h="http://java.sun.com/jsf/html"
                xmlns:rich="http://richfaces.org/rich" xmlns:s="http://jboss.org/schema/seam/taglib"
                xmlns="http://www.w3.org/1999/xhtml">
    <h1>#{managedBean.selectedDomain.name}
        #{managedBean.simulatedActor.name}</h1>
    <s:div id="globalDiv">
        <gri:panel pid="globalPanel">
            <f:facet name="header">
                <s:div>
                    <h:outputText value="#{messages['gazelle.ordermanager.CreateCancelUpdateOrders']}"
                                  rendered="#{not managedBean.workOrder}"/>
                    <h:outputText value="#{messages['gazelle.ordermanager.CreateCancelWorkOrders']}"
                                  rendered="#{managedBean.workOrder}"/>
                </s:div>
            </f:facet>
            <ui:insert name="v251Div"/>
            <ui:insert name="sutConfiguration"/>
            <!-- SUT Selection -->
            <s:div rendered="#{displaySequenceDiagram}">
                <ui:include src="/configuration/initiatorFrame.xhtml">
                    <ui:param name="diagramImg" value="#{managedBean.sequenceDiagramPath}"/>
                    <ui:param name="currentConfig" value="#{userPreferencesManagerBean.selectedSUT}"/>
                    <ui:param name="simuFacility" value="#{managedBean.sendingFacility}"/>
                    <ui:param name="simuApplication" value="#{managedBean.sendingApplication}"/>
                    <ui:param name="sectionsToReRender"
                              value="sendMessageButtonDiv"/>
                    <ui:param name="simulatorConfigurationName"
                              value="#{managedBean.selectedDomain.name} #{managedBean.simulatedActor.name}"/>
                    <ui:param name="availableSuts" value="#{availableSuts}"/>
                </ui:include>
            </s:div>
            <br/>
            <!-- Action selection -->
            <s:div id="availableActionsDiv" rendered="#{managedBean.hl7Messages == null}">
                <div class="form-horizontal">
                    <s:decorate template="/layout/form/_form_field_horizontal_3-9.xhtml">
                        <ui:define name="label">#{messages['gazelle.ordermanager.ActionToPerform']}</ui:define>
                        <ui:param name="id" value="actionIn"/>
                        <h:selectOneMenu value="#{managedBean.orderControlCode}"
                                         styleClass="form-control" id="actionIn">
                            <f:selectItems value="#{managedBean.listAvailableActions()}"/>
                            <a4j:ajax event="change" render="availableActionsDiv, selectionDiv"
                                      listener="#{managedBean.onChangeActionEvent()}"/>
                        </h:selectOneMenu>
                    </s:decorate>
                    <ui:insert name="lawoptions"/>
                    <ui:insert name="messageStructureSelection"/>
                </div>
            </s:div>
            <br/>
            <!-- Message structure selection -->
            <s:div id="selectionDiv" rendered="#{managedBean.hl7Messages == null}">
                #{dataTableStateHolder.setDescendingOn('lastChanged')}
                <!-- New order Div -->
                <s:div id="newOrderDiv" rendered="#{managedBean.orderControlCode.equals(managedBean.new)}">
                    <!-- this div has been added for inserting a panel in which the user can select an order owned by the OF in order
                              to send it as a work order to its automation manager -->
                    <s:div id="orderSelectionForWorkOrderDiv" rendered="#{managedBean.workOrder}">
                        <ui:insert name="orderSelectionForWorkOrder"/>
                    </s:div>
                    <gri:panel pid="encounterSelectionPanel"
                               rendered="#{managedBean.selectedEncounter == null and managedBean.selectPatient}">
                        <f:facet name="header">#{messages['gazelle.ordermanager.PatientAndEncounterSelection']}</f:facet>
                        <s:div styleClass="gzl-never-wrap" id="newEncounterButtons">
                            <a4j:commandLink actionListener="#{managedBean.displayAvailableCountries()}"
                                             render="newOrderDiv" styleClass="gzl-btn-blue"
                                             rendered="#{managedBean.selectionType != 'DDS'}">
                                <h:outputText
                                        value="#{messages['gazelle.ordermanager.NewPatient']}"/>
                            </a4j:commandLink>
                            <a4j:commandLink actionListener="#{managedBean.setSelectionType('PATIENT')}"
                                             render="newOrderDiv" styleClass="gzl-btn-blue"
                                             rendered="#{managedBean.selectionType != 'PATIENT'}">
                                <h:outputText
                                        value="#{messages['gazelle.ordermanager.ExistingPatient']}"/>
                            </a4j:commandLink>
                            <a4j:commandLink actionListener="#{managedBean.setSelectionType('ENCOUNTER')}"
                                             render="newOrderDiv" styleClass="gzl-btn-blue"
                                             rendered="#{managedBean.selectionType != 'ENCOUNTER'}">
                                <h:outputText
                                        value="#{messages['gazelle.ordermanager.ExistingEncounters']}"/>
                            </a4j:commandLink>
                            <a4j:commandLink actionListener="#{managedBean.skipPatientSelection()}"
                                             rendered="#{managedBean.simulatedActor.keyword.equals('ANALYZER') or managedBean.simulatedActor.keyword.equals('ANALYZER_MGR')}"
                                             render="newOrderDiv" styleClass="gzl-btn-orange">
                                <h:outputText value="#{messages['gazelle.ordermanager.DontUseDemographics']}"/>
                            </a4j:commandLink>
                        </s:div>
                        <br/>
                        <!-- Generate a new patient -->
                        <gri:panel rendered="#{managedBean.selectionType == 'DDS'}">
                            <f:facet name="header">
                                #{messages['gazelle.ordermanager.PatientAndEncounterGeneration']}
                            </f:facet>
                            <h:outputText
                                    value="#{messages['gazelle.ordermanager.ChooseACountryForTheGeneratedPatient']}"
                                    styleClass="help-block"/>
                            <ui:include src="/patient/patientGenerator.xhtml">
                                <ui:param name="patientGeneratorBean" value="#{managedBean}"/>
                                <ui:param name="displayAllCriteria" value="true"/>
                                <ui:param name="ddsEndpoint"
                                          value="#{applicationConfiguration.getValueOfVariable('dds_ws_endpoint')}"/>
                            </ui:include>
                            <f:facet name="footer">
                                <a4j:commandButton id="generateButton"
                                                   value="#{messages['gazelle.ordermanager.Generate']}"
                                                   actionListener="#{managedBean.createNewPatientAndEncounter()}"
                                                   styleClass="gzl-btn-blue" render="newOrderDiv"/>
                                <a4j:commandButton value="#{messages['users.Cancel']}"
                                                   actionListener="#{managedBean.cancelPatientCreation()}"
                                                   styleClass="gzl-btn-orange" render="newOrderDiv"/>
                            </f:facet>
                        </gri:panel>
                        <br/>
                        <!-- Select an existing encounter -->
                        <s:div id="encounterSelection"
                               rendered="#{managedBean.selectionType == 'ENCOUNTER'}">
                            <f:subview id="encFilterView">
                                <ui:decorate template="/layout/panels/_panel_filter_criteria.xhtml">

                                    <ui:define name="filter_buttons">
                                        <a4j:commandLink title="#{messages['gazelle.ordermanager.RefreshResults']}"
                                                         render="encounterSelection">
                                            <span class="gzl-icon-refresh"/>
                                        </a4j:commandLink>
                                        <a4j:commandLink title="#{messages['gazelle.hl7.validator.ResetCriteria']}"
                                                         actionListener="#{managedBean.encounterFilter.reset()}"
                                                         render="encounterSelection">
                                            <span class="gzl-icon-times-circle"/>
                                        </a4j:commandLink>
                                    </ui:define>
                                    <ui:include src="/common/filtersOnEncounter.xhtml">
                                        <ui:param name="formId" value="encounterSelection"/>
                                        <ui:param name="filterClass" value="#{managedBean.encounterFilter}"/>
                                    </ui:include>
                                </ui:decorate>
                            </f:subview>
                            <br/>
                            <br/>
                            #{dataTableStateHolder.setDescendingOn('creationDate')}
                            <rich:dataTable id="encountersTable"
                                            value="#{managedBean.encounterFilter.getEncounterFiltered()}" var="enc"
                                            rows="#{dataScrollerMemory.numberOfResultsPerPage}"
                                            render="ds">
                                <ui:include src="/common/encounterColumns.xhtml">
                                    <ui:param name="encounter" value="#{enc}"/>
                                    <ui:param name="displayPatientInfo"
                                              value="true"/>
                                    <ui:param name="extendedTable"
                                              value="false"/>
                                </ui:include>
                                <g:column>
                                    <ui:define name="header">#{messages['users.Action']}</ui:define>
                                    <a4j:commandLink title="#{messages['gazelle.ordermanager.Select']}"
                                                     actionListener="#{managedBean.selectEncounter(enc)}"
                                                     render="newOrderDiv">
                                        <span class="gzl-icon-medkit"/>
                                    </a4j:commandLink>
                                </g:column>
                                <f:facet name="footer">
                                    <ui:include src="/util/datatableFooter.xhtml">
                                        <ui:param name="dataScrollerId" value="ds"/>
                                        <ui:param name="dataTableId" value="encountersTable"/>
                                    </ui:include>
                                </f:facet>
                            </rich:dataTable>
                        </s:div>
                        <!-- Select an existing patient -->
                        <s:div id="patientSelection"
                               rendered="#{managedBean.selectionType == 'PATIENT'}">
                            <f:subview id="patFilterView">
                                <ui:decorate template="/layout/panels/_panel_filter_criteria.xhtml">
                                    <ui:define name="filter_buttons">
                                        <a4j:commandLink title="#{messages['gazelle.ordermanager.RefreshResults']}"
                                                         render="patientSelection">
                                            <span class="gzl-icon-refresh"/>
                                        </a4j:commandLink>
                                        <a4j:commandLink title="#{messages['gazelle.hl7.validator.ResetCriteria']}"
                                                         actionListener="#{managedBean.patientFilter.reset()}"
                                                         render="patientSelection">
                                            <span class="gzl-icon-times-circle"/>
                                        </a4j:commandLink>
                                    </ui:define>
                                    <ui:include src="/common/filtersOnPatient.xhtml">
                                        <ui:param name="formId" value="patientSelection"/>
                                        <ui:param name="filterClass" value="#{managedBean.patientFilter}"/>
                                    </ui:include>
                                </ui:decorate>
                            </f:subview>
                            <br/>
                            <br/>
                            #{dataTableStateHolder.setDescendingOn('creationDate')}
                            <rich:dataTable value="#{managedBean.patientFilter.getPatientsFiltered()}" var="pat"
                                            rows="#{dataScrollerMemory.numberOfResultsPerPage}" id="patientsTable"
                                            render="ds">
                                <ui:include src="/common/patientColumns.xhtml">
                                    <ui:param name="patient" value="#{pat}"/>
                                </ui:include>
                                <g:column>
                                    <ui:define name="header">#{messages['users.Action']}</ui:define>
                                    <a4j:commandLink title="#{messages['gazelle.ordermanager.Select']}"
                                                     actionListener="#{managedBean.createANewEncounterForPatient(pat)}"
                                                     render="newOrderDiv">
                                        <span class="gzl-icon-medkit"/>
                                    </a4j:commandLink>
                                </g:column>
                                <f:facet name="footer">
                                    <ui:include src="/util/datatableFooter.xhtml">
                                        <ui:param name="dataScrollerId" value="ds"/>
                                        <ui:param name="dataTableId" value="patientsTable"/>
                                    </ui:include>
                                </f:facet>
                            </rich:dataTable>
                        </s:div>
                    </gri:panel>
                    <!-- Display information about selected encounter and patient -->
                    <gri:panel rendered="#{managedBean.selectedEncounter != null}">
                        <f:facet name="header">#{messages['gazelle.ordermanager.SelectedPatientAndEncounter']}</f:facet>
                        <ui:include src="/common/displayPatientEncounter.xhtml">
                            <ui:param name="patient" value="#{managedBean.selectedPatient}"/>
                            <ui:param name="encounter" value="#{managedBean.selectedEncounter}"/>
                        </ui:include>
                        <f:facet name="footer">
                            <a4j:commandButton value="#{messages['gazelle.ordermanager.SelectAnotherEncounter']}"
                                               actionListener="#{managedBean.onChangeActionEvent()}"
                                               immediate="true" styleClass="gzl-btn-orange"
                                               render="newOrderDiv"/>
                        </f:facet>
                    </gri:panel>
                    <!-- Display panel to fill the order/specimen/container -->
                    <ui:insert name="newObjectPart"/>
                </s:div>
                <!-- Cancel / discontinue / update orders -->
                <gri:panel pid="cancelDiscontinueOrderDiv"
                           rendered="#{managedBean.selectionType == 'ORDER'}">
                    <f:facet name="header">#{messages['gazelle.ordermanager.OrderSelection_2']}</f:facet>
                    <f:subview id="orderFilterView">
                        <ui:decorate template="/layout/panels/_panel_filter_criteria.xhtml">
                            <ui:define name="filter_buttons">
                                <a4j:commandLink title="#{messages['gazelle.ordermanager.RefreshResults']}"
                                                 render="cancelDiscontinueOrderDiv">
                                    <span class="gzl-icon-refresh"/>
                                </a4j:commandLink>
                                <a4j:commandLink title="#{messages['gazelle.hl7.validator.ResetCriteria']}"
                                                 actionListener="#{managedBean.orderFilter.reset()}"
                                                 render="cancelDiscontinueOrderDiv">
                                    <span class="gzl-icon-times-circle"/>
                                </a4j:commandLink>
                            </ui:define>
                            <ui:include src="/common/filtersOnOrder.xhtml">
                                <ui:param name="filterClass" value="#{managedBean.orderFilter}"/>
                                <ui:param name="formId" value="cancelDiscontinueOrderDiv"/>
                            </ui:include>
                        </ui:decorate>
                    </f:subview>
                    <rich:dataTable value="#{managedBean.orderFilter.getOrders()}" var="orderVar"
                                    rows="#{dataScrollerMemory.numberOfResultsPerPage}" id="orders1Table"
                                    render="ds">
                        <ui:include src="/common/orderColumns.xhtml">
                            <ui:param name="managedBean" value="#{managedBean}"/>
                            <ui:param name="currentOrder" value="#{orderVar}"/>
                            <ui:param name="displayEncounterInfo" value="true"/>
                            <ui:define name="orderStatusColumn">
                                <h:outputText value="#{currentOrder.orderStatus}"/>
                            </ui:define>
                            <ui:define name="orderResultColumn">
                                <h:outputText value="#{currentOrder.orderResultStatus}"/>
                            </ui:define>
                        </ui:include>
                        <g:column>
                            <ui:define name="header">#{messages['users.Action']}</ui:define>
                            <a4j:commandLink title="#{messages['gazelle.ordermanager.CancelOrder']}"
                                             actionListener="#{managedBean.setSelectedOrder(orderVar)}"
                                             oncomplete="jq162('#cancelDiscontinueOrderPanel').modal('show')"
                                             rendered="#{managedBean.orderControlCode.equals(orderSender.cancel) or managedBean.orderControlCode.equals(orderSender.discontinue)}"
                                             render="confirmCancelBtn, cancelContent">
                                <span class="gzl-icon-times-circle"/>
                            </a4j:commandLink>
                            <a4j:commandLink title="#{messages['gazelle.ordermanager.UpdateOrder']}"
                                             actionListener="#{managedBean.setSelectedOrder(orderVar)}"
                                             oncomplete="jq162('#updateOrderStatusPanel').modal('show')"
                                             rendered="#{managedBean.orderControlCode.equals(orderSender.update)}"
                                             render="confirmUpdateBtn, updateContent">
                                <span class="gzl-icon-refresh"/>
                            </a4j:commandLink>
                        </g:column>
                        <f:facet name="footer">
                            <ui:include src="/util/datatableFooter.xhtml">
                                <ui:param name="dataScrollerId" value="ds"/>
                                <ui:param name="dataTableId" value="orders1Table"/>
                            </ui:include>
                        </f:facet>
                    </rich:dataTable>
                </gri:panel>
            </s:div>
            <!-- Exchange messages -->
            <s:div id="hl7MessagesDiv">
                <gri:panel rendered="#{managedBean.hl7Messages != null}">
                    <f:facet name="header">#{messages['gazelle.ordermanager.TestReport']}</f:facet>
                    <ui:include src="/messages/message_table.xhtml">
                        <ui:param name="hl7Messages" value="#{managedBean.hl7Messages}"/>
                    </ui:include>
                    <f:facet name="footer">
                        <a4j:commandButton value="#{messages['gazelle.ordermanager.PerformAnotherTest']}"
                                           styleClass="gzl-btn-blue"
                                           actionListener="#{managedBean.setHl7Messages(null)}" render="globalDiv"/>
                    </f:facet>
                </gri:panel>
            </s:div>
        </gri:panel>
    </s:div>
    <ui:include src="/hl7Initiators/cancelDiscontinueOrderPanel.xhtml">
        <ui:param name="managedBean" value="#{managedBean}"/>
    </ui:include>
    <ui:include src="/hl7Initiators/updateOrderStatusPanel.xhtml">
        <ui:param name="managedBean" value="#{managedBean}"/>
    </ui:include>
</ui:composition>
